.TH gotoline 1 "21 June 1991"
.fi
.SH NAME
Goto (old) line:
.SH DESCRIPTION
This command is used to jump to an absolute line in the current buffer,
an \fIold\fR line number, a particular character position, or a field
on the current line.
.P
By default, just typing in a number goes to the line specified.
The following syntax may be used to go to specific parts of the file.
.P
The value for the line (or column/character position) may be specified
in decimal or hex (by preceding it with 0x).
.P
.TS
center allbox;
cB cB
lw(1i) lw(4i).
Syntax	Description
=
nn	Jump to line nn
-nn	T{
Goto the \fIold\fR line numbered nn. Each line in CRISP has two line
numbers: the current line number, and its old line number. When a file
is read into a buffer, both the old and current line numbers are the same.
As lines get inserted or deleted, the current line number changes but
the old one doesn't. This feature exists to specifically handle the case
where the user is correcting syntax errors in a file, whilst referring
to a list of lines emitted by the compiler. As lines are inserted and
deleted, the old line number stays constant so that the lines referred
to by the compiler can be used without the user having to keep track of
insertions and deletions.
T}
|nn	Go to column position nn.
nn.	Go to the character position nn, with 0 being the start of the buffer.
#nn	T{
Go to the start of field nn on the current line. A field is similar to an
\fIawk(1)\fR field. Fields are delimited by a field separator (default
is tab). The field separator character can be changed by executing
the macro \fIset_fs\fR from the command line.
T}
.TE
.SH MENU/KEYS
This command is accessed via the \f(HB<Alt-G>\fR key sequence.

