.TH format 1 "19 April 1991"
.fi
.SH NAME
Format a region (paragraph or C comment block)
.SH DESCRIPTION
This macro is used to reformat a hilighted region in the current buffer.
The effect of the reformat is dependent on the file extension. There are
two types of formats supported:
.BL
.LI
C style comments. This macro knows how to format comments which are used
at the head of a function and also how to format comments which are a part
of the code.
.LI
Normal text paragraphs.
.LE
.P
Formatting a C style comment involves first removing any comment box
around the existing comments, reformatting the text of the comment as
if it were pure text, and then placing a box around the
comments. Comments which start at the beginning of a line are 
formatted to fill a line. Comments which start indented are formatted
with 40 columns of text per line.
.P
Normal text is formatted in a similar way to a word processor. The user
can set up whether paragraphs are to be left justified or have ragged
margins. 
.P
This macro can be used to reformat multiple paragraphs. A paragraph
boundary is taken as a blank line.
.SH MENU/KEYS
This feature is available via the \f(HB<Ctrl-F>\fR key.
.SH SEE ALSO
Document options, autowrap, margin
.SH BUGS
Reformatting a comment which has an indented list removes the indenting.
