.TH hpcalc 1 "21 April 1991"
.fi
.SH NAME
HP Calculator -- RPN based calculator
.SH DESCRIPTION
The hpcalc macro is an attempt to emulate an HP calculator, hopefully
to eventually contain many of the more sophisticated features. Currently,
this calculator is simply an RPN based calculator similar to the 
\fIcalc\fR macro. This calculator also supports floating point arithmetic
as well as base conversions.
.P
This macro displays a popup window, emulating the HP stack display.
As numbers are typed in, and the <Enter> key is pressed, the numbers
are pushed onto the calculation stack.
.P
Typing an operator key causes the calculation to be performed
straightaway. For example, to add two numbers together, type:
.DS
	'1' <Space> '2' '+'
.DE
.P
(Thats four keystrokes - the number '1', the space bar, the number '2'
and the plus key to add the numbers together.
.P
The hpcalc macro supports octal, hexadecimal and decimal arithmetic.
Non-decimal based numbers may be typed in using the 'C' notation
(i.e. 0 followed by an octal number, or 0x followed by a hexadecimal
one), or using the HP notation of a '#' character followed by the
number and suffixed by a 'd', 'o', or 'h' character to indicate the
base.
.P
Base conversions are accomplished with the following commands:
.VL 10
.LI B->R
Convert binary number to real.
.LI R->B
Convert real number to binary in the current base.
.LE
.P
The current base is set by typing one of: OCT - octal, DEC - decimal,
HEX - hexadecimal, or BIN - binary (not currently supported).
.P
Typing DEPTH pushes the current number of items on the stack onto the
stack.
.P
The calculator also supports the following trig and logarithmic functions:
.DS
	sin, cos, tan
	asin, acos, atan,
	sinh, cosh, tanh,
	sqrt,
	exp, log, log10
.DE
.SH MENU/KEYS
This macro can be accessed from the CRISP features menu or by typing
\f(HBhpcalc\fR at the command prompt.
.SH BUGS
This calculator demonstrates the use of certain esoteric crunch language
features. It is a very trivial calculator but useful. Needs a lot
of work to compare to anybody elses.
.P
All trig functions assume value is in radians.
.P
Out of range for trig functions generate NaN numbers. Should really
give complex results.
